from django.shortcuts import render, render_to_response
from django.http import HttpResponse, HttpResponseBadRequest
from formt import *
from formt import html
from django.middleware.csrf import get_token
import datetime
from django.template import RequestContext


# Create your views here.
serv_schema = {
	"pnum" : field(label="Port Number", n="serv_form",
		ft=ft("int")(required=False)),
	"sname" : field(label="Service Name", n="serv_form",
		ft=ft("string")(required=True, maxlen=40, minlen=2)),
}

def form_one(request):

	def e(f, g):
		h = {'pnum': None, 'sname': None}
		return h[g]

	serv_form = former(serv_schema, {'n': 'serv_form', }, deffunc=e)
	context = {
	'serv_form_html': html.form_string(serv_form),
	}

	if request.method == 'POST':
		# raise Exception(validate_form(serv_form, request.POST))
		a, b, c = validate_form(serv_form, request.POST)
		context['serv_form_html'] = html.form_string(serv_form, d=(a,b,c))
		context['post_data'] = get_form_data(serv_form, request.POST)

	return render_to_response('form_one.html', context, RequestContext(request))


def form_two(request):

	serv_form = former(serv_schema, {'n': 'serv_form', })
	add_field(serv_form, {
		"addr_range": field(label="Address Range", n="serv_form",
			ft=ft("range")(minhigh=10, maxhigh=50)),
		"wid_range": field(label="wid range", n="serv_form",
			ft=ft("range")(minhigh=10, maxlow=50))
	})

	context = {
	'serv_form_html': html.form_string(serv_form),
	}

	if request.method == 'POST':
		# raise Exception(validate_form(serv_form, request.POST))
		a, b, c = validate_form(serv_form, request.POST)
		context['serv_form_html'] = html.form_string(serv_form, d=(a,b,c))
		context['post_data'] = request.POST
		d = {}

		for e in form_iter(serv_form):
			d[e.sname] = ''
			f = e.ft.validators()
			for g, h in enumerate(f):
				d[e.sname] += h.__class__.__name__
				if g != len(serv_form.fields) - 1 :
					d[e.sname] += ',  '

		context['val'] = d

		context['field_err_msgs'] = b
		context['form_err_msgs'] = c

	return render_to_response('form_two.html', context, RequestContext(request))


def form_three(request):

	gender_choices = (('m', 'male'), ('f', 'female'),)
	year_choices = (('2014', '2014'), ('2013', '2013'), ('2012', '2012'),)
	status_choices = (('s', 'single'), ('m', 'married'), ('d', 'divorce'),)

	form_three_schema = {
		'BoolField': field(label="A Boolean Field", n='form_three',
			ft=ft("bool")(question='let value be true?') ),
		'CheckField': field(label="A Single Choice Field", n='form_three',
			ft=ft("choice")(choices=gender_choices, required=True)),
		'MultipleCheckField': field(label="A Multiple Choice Field", n ='form_three',
			ft=ft("multi_choice")(choices=year_choices)),
		'MultipleCheckField2': field(label="Another Multiple Choice Field", n='form_three',
			ft=ft("multi_choice")(choices=status_choices))
	}

	def def_func(form, sname):
		a = {
		'MultipleCheckField2': ['s', 'm'],
		'BoolField': 'on',
		}
		return a.get(sname, None)

	form_three = former(form_three_schema, {'n': 'form_three'}, deffunc=def_func)


	context = {
	'form_three_html': html.form_string(form_three)
	}

	if request.method == 'POST':
		a, b, c = validate_form(form_three, request.POST)
		context['form_three_html'] = html.form_string(form_three, d=(a,b,c))
		context['post_data'] = request.POST

	return render_to_response('form_three.html', context, RequestContext(request))


def form_four(request):
	form_four_schema = {
		'date': field(label="date", n="form_four", ft=ft('date')(required=True)),
		'time': field(label="time", n="form_four", ft=ft('time')()),
		'date_time': field(label="Date and time", n="form_four", ft=ft('datetime')(required=True))
	}

	def def_func(form, sname):
		a = { 'date': datetime.date(2014, 9, 27)}
		return a.get(sname, None)


	class v1(KwargsMixin):
		errcode = 501

		def validate(self):
			if self.form_data['date'] < datetime.date(2014, 1, 1):
				self.err = 1
				return self.errcode

			if self.form_data['date'] > datetime.date(2014, 12, 1):
				self.err = 2
				return self.errcode

		def err_msg(self):
			if self.err == 1:
				return 'the field is less than the minimum date'
			else:
				return 'the data supplied is greater than the maximum date'



	form_four = former(form_four_schema, {'n': 'form_four'}, vs=[v1(), ], deffunc=def_func)
	context = {
		'form_four_html': html.form_string(form_four)
	}

	if request.method == 'POST':
		a, b, c = validate_form(form_four, request.POST)
		context['form_four_html'] = html.form_string(form_four, d=(a,b,c))
		context['post_data'] = get_form_data(form_four, request.POST)
		context['form_err_msgs'] = c

	return render_to_response('form_four.html', context, RequestContext(request))	


